/*
 *  Copyright (C) 2006 David Kozub <zub at linux.fjfi.cvut.cz.nospam>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
A dirty hack that returns the UTF8 represenation of a given unicode character.
*/

#include <stdio.h>
#include <stdlib.h>
#include "to_utf8.h"

#define UTF8_PREFIX1    0xc0   /* '110 00000' */
#define UTF8_PREFIX2    0xe0   /* '1110 0000' */
#define UTF8_PREFIX3    0xf0   /* '11110 000' */

#define UTF8_CONT       0x80   /* '10 000000' */
#define UTF8_CONT_MASK  0x3f   /* '00 111111' */
#define UTF8_CONT_SHIFT 6

/*
 This is naaaasty, I bet. But I was lazy searching for something
 more efficient.
*/

const char *conv_to_utf8(unsigned character)
{
  static char buff[10];

  /* Convert to UTF8 */
  if (character<0x80) {
    /* 0xxxxxxx
       identity: */
    buff[0]=(char)character;
    buff[1]=0;
  } else if (character<0x800) {
    /* 110xxxxx 10xxxxxx */
    buff[1]=UTF8_CONT | (character&UTF8_CONT_MASK);
    character>>=UTF8_CONT_SHIFT;
    buff[0]=UTF8_PREFIX1 | character;
    buff[2]=0;
  } else if (character<0x10000) {
    /* 1110xxxx 10xxxxxx 10xxxxxx */
    buff[2]=UTF8_CONT | (character&UTF8_CONT_MASK);
    character>>=UTF8_CONT_SHIFT;
    buff[1]=UTF8_CONT | (character&UTF8_CONT_MASK);
    character>>=UTF8_CONT_SHIFT;
    buff[0]=UTF8_PREFIX2 | character;
    buff[3]=0;
  } else if (character<0x110000) {
    /* 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx */
    buff[3]=UTF8_CONT | (character&UTF8_CONT_MASK);
    character>>=UTF8_CONT_SHIFT;
    buff[2]=UTF8_CONT | (character&UTF8_CONT_MASK);
    character>>=UTF8_CONT_SHIFT;
    buff[1]=UTF8_CONT | (character&UTF8_CONT_MASK);
    character>>=UTF8_CONT_SHIFT;
    buff[0]=UTF8_PREFIX3 | character;
    buff[4]=0;
  } else {
    fprintf(stderr,"Cannot express character %d in UTF-8.\n",character);
    abort();
  }
   
  return buff;
}
