/*
 *  Copyright (C) 2006 David Kozub <zub at linux.fjfi.cvut.cz.nospam>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "uni_str.h"
#include "trans_tbl.h"

trans_tbl::trans_tbl()
{
  for (int i=0;i<0x100;i++)
    table[i]=NULL;
}

trans_tbl::~trans_tbl()
{
  for (int i=0;i<0x100;i++) {
    delete table[i];
    table[i]=NULL;
  }
}

uni_str* trans_tbl::getAt(unsigned i) const
{
  assert(i<0x100);

//  fprintf(stderr,"Retrieving item %02x (%08x).\n",i,table[i]);
  
  return table[i];
}

void trans_tbl::setAt(unsigned i, const uni_str& s)
{
  assert(i<0x100);

//  fprintf(stderr,"Setting item %02x.\n",i);

  if (table[i]) delete table[i];
  
  table[i]=new uni_str(s);
}
