/*
 *  Copyright (C) 2006 David Kozub <zub at linux.fjfi.cvut.cz.nospam>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
#include "uni_str.h"

void uni_str::copy_from(const uni_str &s)
{
  if (data) delete[] data;
  
  len=s.len;
  data=new unsigned[len];
  memcpy(data,s.data,sizeof(unsigned)*len);
}

void uni_str::set(unsigned* d, unsigned l)
{
  if (data) delete[] data;
  
  len=l;
  data=new unsigned[len];
  memcpy(data,d,sizeof(unsigned)*len);
}

uni_str::uni_str(unsigned* d, unsigned l): len(0), data(NULL)
{
  set(d,l);
}

uni_str::uni_str(const uni_str &s): len(0), data(NULL)
{
  copy_from(s);
}

uni_str::~uni_str()
{
  if (data) {
    delete[] data;
  }
  len=0;
}

uni_str& uni_str::operator=(const uni_str s)
{
  copy_from(s);
  
  return *this;
}
